<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUyeAdres ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUyeAdres
 * @subpackage Arrays
 */
class ArrayOfUyeAdres extends AbstractStructArrayBase
{
    /**
     * The UyeAdres
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UyeAdres[]
     */
    public $UyeAdres;
    /**
     * Constructor method for ArrayOfUyeAdres
     * @uses ArrayOfUyeAdres::setUyeAdres()
     * @param \StructType\UyeAdres[] $uyeAdres
     */
    public function __construct(array $uyeAdres = array())
    {
        $this
            ->setUyeAdres($uyeAdres);
    }
    /**
     * Get UyeAdres value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UyeAdres[]|null
     */
    public function getUyeAdres()
    {
        return isset($this->UyeAdres) ? $this->UyeAdres : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUyeAdres method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUyeAdres method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUyeAdresForArrayConstraintsFromSetUyeAdres(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUyeAdresUyeAdresItem) {
            // validation for constraint: itemType
            if (!$arrayOfUyeAdresUyeAdresItem instanceof \StructType\UyeAdres) {
                $invalidValues[] = is_object($arrayOfUyeAdresUyeAdresItem) ? get_class($arrayOfUyeAdresUyeAdresItem) : sprintf('%s(%s)', gettype($arrayOfUyeAdresUyeAdresItem), var_export($arrayOfUyeAdresUyeAdresItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UyeAdres property can only contain items of type \StructType\UyeAdres, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UyeAdres value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UyeAdres[] $uyeAdres
     * @return \ArrayType\ArrayOfUyeAdres
     */
    public function setUyeAdres(array $uyeAdres = array())
    {
        // validation for constraint: array
        if ('' !== ($uyeAdresArrayErrorMessage = self::validateUyeAdresForArrayConstraintsFromSetUyeAdres($uyeAdres))) {
            throw new \InvalidArgumentException($uyeAdresArrayErrorMessage, __LINE__);
        }
        if (is_null($uyeAdres) || (is_array($uyeAdres) && empty($uyeAdres))) {
            unset($this->UyeAdres);
        } else {
            $this->UyeAdres = $uyeAdres;
        }
        return $this;
    }
    /**
     * Add item to UyeAdres value
     * @throws \InvalidArgumentException
     * @param \StructType\UyeAdres $item
     * @return \ArrayType\ArrayOfUyeAdres
     */
    public function addToUyeAdres(\StructType\UyeAdres $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UyeAdres) {
            throw new \InvalidArgumentException(sprintf('The UyeAdres property can only contain items of type \StructType\UyeAdres, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UyeAdres[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UyeAdres|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UyeAdres|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UyeAdres|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UyeAdres|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UyeAdres|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UyeAdres
     */
    public function getAttributeName()
    {
        return 'UyeAdres';
    }
}
