<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectUyeler StructType
 * @subpackage Structs
 */
class SelectUyeler extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The filtre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UyeFiltre
     */
    public $filtre;
    /**
     * The sayfalama
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UyeSayfalama
     */
    public $sayfalama;
    /**
     * Constructor method for SelectUyeler
     * @uses SelectUyeler::setUyeKodu()
     * @uses SelectUyeler::setFiltre()
     * @uses SelectUyeler::setSayfalama()
     * @param string $uyeKodu
     * @param \StructType\UyeFiltre $filtre
     * @param \StructType\UyeSayfalama $sayfalama
     */
    public function __construct($uyeKodu = null, \StructType\UyeFiltre $filtre = null, \StructType\UyeSayfalama $sayfalama = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setFiltre($filtre)
            ->setSayfalama($sayfalama);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SelectUyeler
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get filtre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UyeFiltre|null
     */
    public function getFiltre()
    {
        return isset($this->filtre) ? $this->filtre : null;
    }
    /**
     * Set filtre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UyeFiltre $filtre
     * @return \StructType\SelectUyeler
     */
    public function setFiltre(\StructType\UyeFiltre $filtre = null)
    {
        if (is_null($filtre) || (is_array($filtre) && empty($filtre))) {
            unset($this->filtre);
        } else {
            $this->filtre = $filtre;
        }
        return $this;
    }
    /**
     * Get sayfalama value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UyeSayfalama|null
     */
    public function getSayfalama()
    {
        return isset($this->sayfalama) ? $this->sayfalama : null;
    }
    /**
     * Set sayfalama value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UyeSayfalama $sayfalama
     * @return \StructType\SelectUyeler
     */
    public function setSayfalama(\StructType\UyeSayfalama $sayfalama = null)
    {
        if (is_null($sayfalama) || (is_array($sayfalama) && empty($sayfalama))) {
            unset($this->sayfalama);
        } else {
            $this->sayfalama = $sayfalama;
        }
        return $this;
    }
}
