<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateUyeIzinRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UpdateUyeIzinRequest
 * @subpackage Structs
 */
class UpdateUyeIzinRequest extends AbstractStructBase
{
    /**
     * The Mail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Mail;
    /**
     * The MailIzin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $MailIzin;
    /**
     * The SmsIzin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $SmsIzin;
    /**
     * The Tarih
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tarih;
    /**
     * The TelefonNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TelefonNo;
    /**
     * The UyeID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $UyeID;
    /**
     * Constructor method for UpdateUyeIzinRequest
     * @uses UpdateUyeIzinRequest::setMail()
     * @uses UpdateUyeIzinRequest::setMailIzin()
     * @uses UpdateUyeIzinRequest::setSmsIzin()
     * @uses UpdateUyeIzinRequest::setTarih()
     * @uses UpdateUyeIzinRequest::setTelefonNo()
     * @uses UpdateUyeIzinRequest::setUyeID()
     * @param string $mail
     * @param bool $mailIzin
     * @param bool $smsIzin
     * @param string $tarih
     * @param string $telefonNo
     * @param int $uyeID
     */
    public function __construct($mail = null, $mailIzin = null, $smsIzin = null, $tarih = null, $telefonNo = null, $uyeID = null)
    {
        $this
            ->setMail($mail)
            ->setMailIzin($mailIzin)
            ->setSmsIzin($smsIzin)
            ->setTarih($tarih)
            ->setTelefonNo($telefonNo)
            ->setUyeID($uyeID);
    }
    /**
     * Get Mail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMail()
    {
        return isset($this->Mail) ? $this->Mail : null;
    }
    /**
     * Set Mail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mail
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setMail($mail = null)
    {
        // validation for constraint: string
        if (!is_null($mail) && !is_string($mail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mail, true), gettype($mail)), __LINE__);
        }
        if (is_null($mail) || (is_array($mail) && empty($mail))) {
            unset($this->Mail);
        } else {
            $this->Mail = $mail;
        }
        return $this;
    }
    /**
     * Get MailIzin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getMailIzin()
    {
        return isset($this->MailIzin) ? $this->MailIzin : null;
    }
    /**
     * Set MailIzin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $mailIzin
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setMailIzin($mailIzin = null)
    {
        // validation for constraint: boolean
        if (!is_null($mailIzin) && !is_bool($mailIzin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($mailIzin, true), gettype($mailIzin)), __LINE__);
        }
        if (is_null($mailIzin) || (is_array($mailIzin) && empty($mailIzin))) {
            unset($this->MailIzin);
        } else {
            $this->MailIzin = $mailIzin;
        }
        return $this;
    }
    /**
     * Get SmsIzin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getSmsIzin()
    {
        return isset($this->SmsIzin) ? $this->SmsIzin : null;
    }
    /**
     * Set SmsIzin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $smsIzin
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setSmsIzin($smsIzin = null)
    {
        // validation for constraint: boolean
        if (!is_null($smsIzin) && !is_bool($smsIzin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($smsIzin, true), gettype($smsIzin)), __LINE__);
        }
        if (is_null($smsIzin) || (is_array($smsIzin) && empty($smsIzin))) {
            unset($this->SmsIzin);
        } else {
            $this->SmsIzin = $smsIzin;
        }
        return $this;
    }
    /**
     * Get Tarih value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTarih()
    {
        return isset($this->Tarih) ? $this->Tarih : null;
    }
    /**
     * Set Tarih value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tarih
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setTarih($tarih = null)
    {
        // validation for constraint: string
        if (!is_null($tarih) && !is_string($tarih)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tarih, true), gettype($tarih)), __LINE__);
        }
        if (is_null($tarih) || (is_array($tarih) && empty($tarih))) {
            unset($this->Tarih);
        } else {
            $this->Tarih = $tarih;
        }
        return $this;
    }
    /**
     * Get TelefonNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTelefonNo()
    {
        return isset($this->TelefonNo) ? $this->TelefonNo : null;
    }
    /**
     * Set TelefonNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $telefonNo
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setTelefonNo($telefonNo = null)
    {
        // validation for constraint: string
        if (!is_null($telefonNo) && !is_string($telefonNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($telefonNo, true), gettype($telefonNo)), __LINE__);
        }
        if (is_null($telefonNo) || (is_array($telefonNo) && empty($telefonNo))) {
            unset($this->TelefonNo);
        } else {
            $this->TelefonNo = $telefonNo;
        }
        return $this;
    }
    /**
     * Get UyeID value
     * @return int|null
     */
    public function getUyeID()
    {
        return $this->UyeID;
    }
    /**
     * Set UyeID value
     * @param int $uyeID
     * @return \StructType\UpdateUyeIzinRequest
     */
    public function setUyeID($uyeID = null)
    {
        // validation for constraint: int
        if (!is_null($uyeID) && !(is_int($uyeID) || ctype_digit($uyeID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($uyeID, true), gettype($uyeID)), __LINE__);
        }
        $this->UyeID = $uyeID;
        return $this;
    }
}
