<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UyeGirisi StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UyeGirisi
 * @subpackage Structs
 */
class UyeGirisi extends AbstractStructBase
{
    /**
     * The Admin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Admin;
    /**
     * The Mail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Mail;
    /**
     * The Otp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Otp;
    /**
     * The Sifre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Sifre;
    /**
     * Constructor method for UyeGirisi
     * @uses UyeGirisi::setAdmin()
     * @uses UyeGirisi::setMail()
     * @uses UyeGirisi::setOtp()
     * @uses UyeGirisi::setSifre()
     * @param bool $admin
     * @param string $mail
     * @param string $otp
     * @param string $sifre
     */
    public function __construct($admin = null, $mail = null, $otp = null, $sifre = null)
    {
        $this
            ->setAdmin($admin)
            ->setMail($mail)
            ->setOtp($otp)
            ->setSifre($sifre);
    }
    /**
     * Get Admin value
     * @return bool|null
     */
    public function getAdmin()
    {
        return $this->Admin;
    }
    /**
     * Set Admin value
     * @param bool $admin
     * @return \StructType\UyeGirisi
     */
    public function setAdmin($admin = null)
    {
        // validation for constraint: boolean
        if (!is_null($admin) && !is_bool($admin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($admin, true), gettype($admin)), __LINE__);
        }
        $this->Admin = $admin;
        return $this;
    }
    /**
     * Get Mail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMail()
    {
        return isset($this->Mail) ? $this->Mail : null;
    }
    /**
     * Set Mail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mail
     * @return \StructType\UyeGirisi
     */
    public function setMail($mail = null)
    {
        // validation for constraint: string
        if (!is_null($mail) && !is_string($mail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mail, true), gettype($mail)), __LINE__);
        }
        if (is_null($mail) || (is_array($mail) && empty($mail))) {
            unset($this->Mail);
        } else {
            $this->Mail = $mail;
        }
        return $this;
    }
    /**
     * Get Otp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOtp()
    {
        return isset($this->Otp) ? $this->Otp : null;
    }
    /**
     * Set Otp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $otp
     * @return \StructType\UyeGirisi
     */
    public function setOtp($otp = null)
    {
        // validation for constraint: string
        if (!is_null($otp) && !is_string($otp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($otp, true), gettype($otp)), __LINE__);
        }
        if (is_null($otp) || (is_array($otp) && empty($otp))) {
            unset($this->Otp);
        } else {
            $this->Otp = $otp;
        }
        return $this;
    }
    /**
     * Get Sifre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSifre()
    {
        return isset($this->Sifre) ? $this->Sifre : null;
    }
    /**
     * Set Sifre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sifre
     * @return \StructType\UyeGirisi
     */
    public function setSifre($sifre = null)
    {
        // validation for constraint: string
        if (!is_null($sifre) && !is_string($sifre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sifre, true), gettype($sifre)), __LINE__);
        }
        if (is_null($sifre) || (is_array($sifre) && empty($sifre))) {
            unset($this->Sifre);
        } else {
            $this->Sifre = $sifre;
        }
        return $this;
    }
}
